﻿//    Copyright (C) 2013 Jay Herman

//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//  THIS PROGRAM IS VERSION 3.07  February 2016

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using ORTS.Menu;
using System.Windows.Forms;
using System.Diagnostics;

namespace APKExtractor
{
    class FolderHelper
    {
        public static List<string> profiles = new List<string>();
        public static List<string> allFolders = new List<string>();

        public static List<String> trainexe = new List<String>();
        static int folderCount = 0;
        static string folderChecked = "";
        
        public static bool TryOpenRailsFolder(string routeFolderName, ref string folder)                        // ORIGINAL
        {
            folder = null;
            string firstMatch = "";
            int profilesCntr = 0;                               // create counter for matching profiles

            foreach (Folder ORFolder in Folder.GetFolders())
            {
                allFolders.Add(ORFolder.Path);
            }
            using (mstsSearch MSTSsearch = new mstsSearch())
            {
                MSTSsearch.ShowDialog();
                List<string> trainExe = new List<string>(mstsSearch.trainexe);

                //  Combine MSTS search folders with those from the Open Rails profiles
                if (trainExe.Count > 0)
                {
                    foreach (string element in trainExe)
                    {
                        if (!allFolders.Contains(element))
                        {
                            allFolders.Add(element);
                        }
                    }
                }
            }
            allFolders.Sort();

                foreach (string trying in allFolders)
                {
                    if (TryFolder(routeFolderName, trying))
                    {
                        profilesCntr++;                               // increase counter by 1
                        //     if (profilesCntr == 1) { firstMatch = trying.Path; }
                        if (profilesCntr == 1)
                        {
                            firstMatch = trying;
                        }
                        //     profiles.Add(trying.Path);                    //  store path in next array position
                        profiles.Add(trying);
                    }
                }  
            if (profilesCntr == 1)                               // if there's only one matching installation
            {
               folder = firstMatch;                              // set 'folder' to the first/only match
               return true;                                      // quit loop and return to caller as 'true'
            }
            else
            {
                if (profilesCntr == 0)                           //  if route not present in any installations   
                {
                    return false;                                //  return as 'not found'
                }
                else                                             //  otherwise display all installations for selection
                {
                    using (ProfilePicker profilePicker = new ProfilePicker()) 
                    {
                        profilePicker.ShowDialog();

                        folder = profilePicker.ProfilePicked;     //  set 'folder' to selected installation  
                        if (folder == "")                         //  but if it's null,
                        {
                            return false;                         //   return as 'not found'
                        }
                        else                                      //  otherwise   
                        {
                            return true;                          //  return as 'found'
                        }
                    }
                }
             }  
        
        } // End of TryOpenRailsFolder

        public static bool TryFolder(string routeFolderName, string folder)
        {
            string routesFolder = Path.Combine(folder, "routes\\" + routeFolderName);

            return Directory.Exists(routesFolder);
        }  // End of TryFolder

    }  // End of Class FolderHelper

}  // End of namespace APKExtractor
