﻿//    Copyright (C) 2013 Jay Herman

//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.

//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.

//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace APKExtractor
{
    public partial class FolderPicker : Form
    {
        private string folderPicked = "";
        public string zipPicked = "";

        public string FolderPicked
        {
            get {return folderPicked; }
        }

        public string ZipPicked
        {
            get { return zipPicked; }
        }

        public FolderPicker()
        {
            InitializeComponent();

                radioButtonDirectory.Checked = true;
     
        }

        private void radioButtonDirectory_CheckedChanged(object sender, EventArgs e)
        {
            textBoxDirectory.Enabled = radioButtonDirectory.Checked;
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (radioButtonZip.Checked)
            {
                folderPicked = "Zip";
            }
            else
            {

                    if (textBoxDirectory.Text.Length == 0)
                    {
                        MessageBox.Show("No folder has been selected.\n\nPress OK, then make your selection.", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Error);
                        return;
                    }
                    folderPicked = textBoxDirectory.Text;

            }
            DialogResult = DialogResult.OK;
            this.Close(); 
        }

        private void buttonBrowse_Click(object sender, EventArgs e)
        {
		    radioButtonDirectory.Checked = true;
            if (folderBrowserDialog.ShowDialog() == DialogResult.OK)
                textBoxDirectory.Text = folderBrowserDialog.SelectedPath;
        }

        private void FolderPicker_Load(object sender, EventArgs e)
        {

        }

        private void textBoxDirectory_TextChanged(object sender, EventArgs e)
        {

        }
    }
}