﻿//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    A copy of the GNU General Public License can be seen at  
//    <http://www.gnu.org/licenses/>.
//
// APKExtractor v3.07  February 2016  G. Saunders (slipperman12 on UKTS)
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace APKExtractor
{
    public partial class mstsSearch : Form
    {
        public static List<string> mstsCheck = new List<string>();
        public static List<string> trainexe = new List<string>();
        static int folderCount = 0;
        static string folderChecked = "";
        string mstsDrives = "";
        int validDrive = 0;
        string driveCheck = "";
        int commaPosn;
        string dispFolder;
        bool cancelWork = false;

        public mstsSearch()
        {
            InitializeComponent();
            mstsText1.Select();
        }

        public void mstsb1Search_Click(object sender, EventArgs e)
        {
            // Read values entered in mstsText1, split into individual letters
            // and pass them to the mstsSearch routine
            mstsCheck.Clear();
            errMsg.Text = "";
            validDrive = 0;
            mstsDrives = mstsText1.Text.ToUpper();
            if (mstsDrives == "")
            {
                userMsg.Text = "No drive letters entered - please try again.";
                mstsText1.Select();
            }
            else
            {
                if (mstsDrives == "")
                {
                    userMsg.Text = "No drive letters entered - please try again!";
                    mstsText1.Select();
                }
                else
                {
                    if (mstsDrives.Length > 1 && mstsDrives.Substring(1, 1) == ":")
                    {
                        mstsFolder();
                    }
                    else
                    {

                        for (int i = 0; i < mstsDrives.Length; i++)
                        {
                            if (mstsDrives.Substring(i, 1) == " " || mstsDrives.Substring(i, 1) == ",")
                            {
                                continue;
                            }
                            driveCheck = mstsDrives.Substring(i, 1) + @":\";

                            if (!Directory.Exists(driveCheck))
                            {
                                userMsg.Text = "Drive " + driveCheck + " doesn't exist - please re-enter.";
                                validDrive++;
                                mstsText1.Text = String.Empty;
                                mstsText1.Select();
                            }
                            else
                            {
                                mstsCheck.Add(driveCheck);

                            }
                        }
                    }
                    if (validDrive == 0) 
                    {
                        mstsb2NoSearch.Hide(); mstsb3Cancel.Show();
                        mstsText1.Font = new Font("Arial", 8);
                        userMsg.ForeColor = System.Drawing.Color.Black;
                        userMsg.Text = "Please wait.....";
                        backgroundWorker1.RunWorkerAsync();
                    }
                }
            }
            
        }

        private void mstsb2NoSearch_Click(object sender, EventArgs e)
        {
            // Continue with original v3.04b program
            this.Close();
        }

        public void mstsText1_TextChanged(object sender, EventArgs e)
        {
            
        }

        public void mstsFolder()
        {
            commaPosn = mstsDrives.IndexOf(",");
            if (commaPosn != -1)
            {
                mstsCheck.Add(mstsDrives.Substring(0, commaPosn));
                if (mstsDrives.Length > commaPosn + 1)
                {
                    if (mstsDrives.Substring(commaPosn + 1, 1) == " ")
                    {
                        mstsCheck.Add(mstsDrives.Substring(commaPosn + 2, mstsDrives.Length - commaPosn - 2));
                    }
                    else
                    {
                        mstsCheck.Add(mstsDrives.Substring(commaPosn + 1, mstsDrives.Length - commaPosn - 1));
                    }
                }
            }
            else
            {
                mstsCheck.Add(mstsDrives);
            }
            for (int i = 0; i < mstsCheck.Count; i++)
            {
                if (!Directory.Exists(mstsCheck[i]))
                {
                    userMsg.Text = "Directory " + mstsCheck[i] + " doesn't exist. \n  Please re-enter";
                    validDrive++;
                    mstsCheck.Clear();
                    mstsText1.Clear(); mstsText1.Select();
                }
            }
        }

        public void searchDrives()
        {
            if (mstsCheck.Count > 0)
            {
                    foreach (string s in mstsCheck)
                    {
                        ShowAllFoldersUnder(s);
                    }
            }
        }

        public void ShowAllFoldersUnder(string path)
        {
                try
                {
                    foreach (string folder in Directory.GetDirectories(path))
                    {
                        if (!backgroundWorker1.CancellationPending)
                        {
                            if (folder.Length < 46)
                            {
                                dispFolder = folder;
                            }
                            else
                            {
                                dispFolder = folder.Substring(0, 20) + "....." + folder.Substring(folder.Length - 20);
                            }
                            backgroundWorker1.ReportProgress(0, dispFolder);
                            if (!folder.Contains("Windows") && !folder.Contains("RECYCLE"))   // Omit some system folders
                            {
                                if (File.Exists(folder + @"\train.exe") && File.Exists(folder + @"\ebueula1.dll"))  // If there is a file called train.exe in the folder
                                {
                                    folderCount++;                        //  Increase count by 1   
                                    trainexe.Add(folder);   //  Save path in trainexe list 
                                    folderChecked = folder;
                                }
                                if (folderChecked != folder)
                                {
                                    ShowAllFoldersUnder(folder);
                                }
                            } // Windows check

                        }  // if not bgw cancel
                         else
                        {
                            cancelWork = true;
                             folderCount = 0;
                             trainexe.Clear();
                             return;
                         }
                    }  // foreach
                }
                catch (UnauthorizedAccessException)
                {
                }
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            if (backgroundWorker1.CancellationPending)
            {
                e.Cancel = true;
                return;
            }
            else
            {
                searchDrives();
            }
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            mstsText1.Text = e.UserState as String;
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            mstsText1.Text = "";
            mstsText1.Select();
            mstsb3Cancel.Hide(); mstsb2NoSearch.Show();
            if (cancelWork)
            {
                userMsg.ForeColor = System.Drawing.Color.Red;
                userMsg.Text = "Search cancelled";
                cancelWork = false;
            }
            else
            {
                userMsg.ForeColor = System.Drawing.Color.Green;
                userMsg.Text = "Search completed";  // This is not normally shown because the Form is closed!
                this.Close();
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            backgroundWorker1.CancelAsync();
        }       
    }
}
